//************************************************************
//  University of Patras
//	Department of Electrical Engineering & Computer Technology
//
//	Course: Parallel Programming in AI
//	Week 05: OpenMp
//
//  Description: Simple examples  in openMP
//  	Pi01.c: Espimation of pi by Monte Carlo methods
//	Author: Evangelos Dermatas
//	v0.1
/*
*********************************************************************
gcc -v:	gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS: 	Linux Ubuntu 18.04
CPU:	8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:	gcc Pi01rand.c -o Pi01rand -fopenmp -lm -O3
Executing:	./Pi01rand

pi= 3.14160294355377179

real	0m1.701s
user	0m4.498s
sys	0m7.970s

*/
//************************************************************

#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include <math.h>


#define N 10000000

// **************************************************************
int main(void)
{
	double sum = 0 ;

#pragma omp parallel for simd reduction(+:sum)
	for( int i = 0 ; i < N ; i++ ) {
		double x = ((double)rand())/RAND_MAX ;
		sum += sqrt( 1.0 - x*x ) ;
		}

	printf( "pi=%20.17lf\n", 4.0 * sum / N ) ;
	return 0 ;
}
